package com.liang.dao;

import com.liang.entity.PrjPayplan;
import com.liang.entity.PrjPayplanXg;
import org.apache.ibatis.annotations.Param;
import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Pageable;

import java.util.List;

public interface PrjPayplanXgDao {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    PrjPayplanXg queryById(Integer id);

    /**
     * 查询指定行数据
     *
     * @param prjPayplan 查询条件
     * @param pageable   分页对象
     * @return 对象列表
     */
    List<PrjPayplanXg> queryAllByLimit(PrjPayplanXg prjPayplan, @Param("pageable") Pageable pageable);

    /**
     * 统计总行数
     *
     * @param prjPayplan 查询条件
     * @return 总行数
     */
    long count(PrjPayplanXg prjPayplan);

    /**
     * 新增数据
     *
     * @param prjPayplan 实例对象
     * @return 影响行数
     */
    int insert(PrjPayplanXg prjPayplan);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<PrjPayplan> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<PrjPayplanXg> entities);

    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<PrjPayplan> 实例对象列表
     * @return 影响行数
     * @throws org.springframework.jdbc.BadSqlGrammarException 入参是空List的时候会抛SQL语句错误的异常，请自行校验入参
     */
    int insertOrUpdateBatch(@Param("entities") List<PrjPayplan> entities);

    /**
     * 修改数据
     *
     * @param prjPayplan 实例对象
     * @return 影响行数
     */
    int update(PrjPayplanXg prjPayplan);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 影响行数
     */
    int deleteById(Integer id);

    /**
     * 批量删除付款计划
     *
     * @param idList
     * @return
     */
    int batchDelete(List<Integer> idList);

    /**
     * 获取付款计划列表
     *
     * @return
     */
    List<PrjPayplanXg> getPayPlanList(Integer ht);

    /**
     * 批量删除项目人员
     *
     * @param htList
     * @return
     */
    int batchDeleteByHt(List<Integer> htList);

    List<PrjPayplan> queryByHtId(Integer htId);

    void deleteBtHtId(Integer htId);
}
